

!!! Listing 1:

(autoload 'xml-mode "psgml" "Major mode to edit XML files." t)
(autoload 'sgml-mode "psgml" "Major mode to edit SGML files." t )

; Die verschiedenen Modes Dateiendungen zuordnen
(setq auto-mode-alist
      (append
       (list
        '("\\.html$" . html-mode)
        '("\\.sgm$" . sgml-mode) 
        '("\\.sgml$" . sgml-mode) 
        '("\\.xml$" . xml-mode))
       auto-mode-alist))

; Die DTD automatisch lesen
(setq sgml-auto-activate-dtd t)
; Beim Einfuegen eines Start-Tags auch das End-Tag einfuegen
(setq sgml-balanced-tag-edit t)
; Notwendige Kind-Elemente gleich mit einfuegen
(setq sgml-auto-insert-required-elements t)
; Anzahl der Leerzeichen beim Einruecken
(setq sgml-indent-step 2)

; Die SGML-/XML-Katalogdateien
(setq sgml-catalog-files 
      '("~/docbook/xml/dtd/4.1.2/docbook.cat"
	"/usr/local/lib/sgml/CATALOG"
	"/etc/sgml/catalog"
	"CATALOG"))

; Das Syntax-Highlighting konfigurieren...
(setq sgml-markup-faces '((doctype . bold)
			  (comment . font-lock-comment-face)
			  (start-tag . font-lock-keyword-face)
			  (end-tag . font-lock-keyword-face)
			  (pi . bold)
			  (sgml . bold)
			  (entity . font-lock-type-face)))
; ...und einschalten.
(setq sgml-set-face t)


;; Einruecken der gesamten Datei im Buffer auf Tastendruck
(defun xml-indent-buffer
  "Indents the current buffer, one line at a time"
  (interactive "*")
  (save-excursion
    (goto-char (point-min))
    (while (= (forward-line 1) 0)
      (sgml-indent-or-tab))))
(define-key xml-mode-map [(control c) (control b)] 'xml-indent-buffer)

;; Beispiel fuer Funktionen und Tastendefinitionen im XML-mode
(add-hook 'xml-mode-hook 
	  (function 
	   (lambda()
	     (defun xml-docbook-para ()
	       "Insert para tags"
	       (interactive)
	       (sgml-insert-element 'para))
	     (define-key xml-mode-map [(control c) p] 'xml-docbook-para))))


